/*

	This program is free software; you can redistribute it and/or modify

	it under the terms of the GNU General Public License version 2 

	as published by the Free Software Foundation.



	This program is distributed in the hope that it will be useful,

	but WITHOUT ANY WARRANTY; without even the implied warranty of

	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the

	GNU General Public License for more details.



	You should have received a copy of the GNU General Public License

	along with this program; if not, write to the Free Software

	Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA





	Copyright (C) 2006  Thierry Berger-Perrin <tbptbp@gmail.com>

*/

#include "specifics.h"
#include "ressource.h"



namespace rsc {

	#if defined __MSVC__
		#pragma const_seg(push, pristine, ".RSC")

	#elif defined __ICC_MSVC__

		// annoying as usual.

		#pragma warning(disable : 1026) // pff. pragma const_seg should be at global scope 

		#pragma const_seg(".RSC")

	#endif



	namespace console_font {
		#include "ressource_console_font.cc"
	}

	#if defined __MSVC__
		#pragma const_seg(pop, pristine)
	#endif
}

